#ifndef _GGI_DM_H
#define _GGI_DM_H

#include <ggi/ggi.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GGIDM_ACQUIRED				0x00000001
#define GGIDM_STORE_MASK			0x00000006
#define GGIDM_STORE_VIDEOMEMORY			0x00000002
#define GGIDM_STORE_SYSTEMMEMORY		0x00000004
#define GGIDM_STORE_DONTWORRY			0x00000000

#define GGIDM_ERR_OK				0
#define GGIDM_ERR_BADDRAWMAP			(-1)
#define GGIDM_ERR_NOTACQUIRED			(-2)
#define GGIDM_ERR_INVALIDATED			(-3)
#define GGIDM_ERR_INVALID			(-4)
#define GGIDM_ERR_IO				(-5)
#define GGIDM_ERR_INTERNAL			(-6)
#define GGIDM_ERR_NOTIMPLEMENTED		(-7)
#define GGIDM_ERR_OUTOFVIDEOMEMORY		(-8)


#ifndef _BUILDING_LIBGGI
typedef void *ggidm_drawmap;
#endif

int ggiDMInit(void);
int ggiDMExit(void);

int ggiDMAttach(ggi_visual_t vis);
int ggiDMDetach(ggi_visual_t vis);

int ggiDMSetMode(ggi_visual_t vis, int sizex, int sizey, int frames,
		 ggi_graphtype type);

ggidm_drawmap ggiDMAddDrawmap(ggi_visual_t vis, int sizex, int sizey, 
			      int flags);
ggidm_drawmap ggiDMGetVisibleDrawmap(ggi_visual_t vis, int frame);
int ggiDMFlip(ggi_visual_t vis);

int ggiDMCloseDrawmap(ggidm_drawmap dm);
int ggiDMFlush(ggidm_drawmap dm);
int ggiDMAcquired(ggidm_drawmap dm);
int ggiDMAcquire(ggidm_drawmap dm, int acquire);
int ggiDMBlit(ggidm_drawmap dest, int destx, int desty,
	      ggidm_drawmap src, int srcx, int srcy, int dx, int dy,
	      int flags);
int ggiDMBlitToVisual(ggi_visual_t dest, int destx, int desty,
		      ggidm_drawmap src, int srcx, int srcy, int dx, int dy,
		      int flags);
int ggiDMBlitFromVisual(ggidm_drawmap dest, int destx, int desty,
			ggi_visual_t src, int srcx, int srcy, int dx, int dy,
			int flags);
int ggiDMPutBox(ggidm_drawmap dest, int destx, int desty,
	        void *src, int dx, int dy, int flags);
int ggiDMGetBox(void *dest, ggidm_drawmap src, int srcx, int srcy, 
		int dx, int dy, int flags);

ggi_visual_t ggiDMGetVisual(ggidm_drawmap dm);

#ifdef __cplusplus
};
#endif /* __cplusplus */

#endif /* _GGI_DM_H */
